# encoding: utf-8

module Mysqlknife
  class CLI < Thor
    class_option :debug, :type => :boolean

    def initialize(*args)
      super

      $DEBUG = options[:debug]
    end

    desc 'config [CONFIG]', 'Show connection details.'
    def config(conn = nil)
      config = Parameter::Config.new
      config.connection = conn
      config.connections
      config.show
    end

    desc 'console [CONFIG] [HOST]', 'Connect to specific CONNECTION.'
    option :execute,
           desc: 'Execute query.',
           type: :string,
           aliases: :e
    def console(conn = nil, host = nil)
      console = Parameter::Console.new
      console.connection = conn
      console.host       = host
      console.execute    = options[:execute]
      console.connections
      console.hosts
      console.connect
    end

    desc 'describe [CONFIG] [HOST] [DATABASE] [TABLE]', 'Describe database, table, keys details.'
    def describe(conn = nil, host = nil, database = nil, table = nil)
      describe = Parameter::Describe.new
      describe.connection = conn
      describe.host       = host
      describe.database   = database
      describe.table      = table
      describe.connections
      describe.hosts
      describe.connect
    end

    desc 'command [CONFIG] [HOST] [COMMAND]', 'Execute specific command line.'
    def command(conn = nil, host = nil, cmd = nil)
      command = Parameter::Command.new
      command.connection = conn
      command.host       = host
      command.cmd        = cmd
      command.connections
      command.hosts
      command.commands
      command.connect
    end

    desc 'version', 'Show version number.'
    def version
      puts Mysqlknife::VERSION
    end
  end
end
