# encoding: utf-8

module Mysqlknife
  class Command
    def initialize
      @config = Configs.instance
      @ssh    = SSH.new
      @iterm  = Iterm.new
    end

    def execute(cmd)
      return false if cmd.nil?

      @iterm.color(@config.color)
      @iterm.name(@config.name)

      if @config.ssh[:use]
        cmd = @ssh.execute(cmd)
      end

      Mysqlknife::Log.new.command(cmd)
      system(cmd)
    ensure
      @iterm.name
      @iterm.reset
    end
  end
end
