# encoding: utf-8

module Mysqlknife
  class Mysql
    def initialize
      @config = Configs.instance
    end

    def command?(name)
      `which #{name}`
      $?.success?
    end

    def check
      command?('mysql')
      command?('mysqlshow')
    end

    def purge(string)
      string.squeeze(' ').strip
    end

    def parse(command)
      host     = @config.host
      port     = @config.mysql[:port]
      username = @config.mysql[:username]
      password = password(@config.mysql[:password])
      command  = eval("\"#{command}\"")
      purge(command)
    end

    def prompt
      if !!(@config.host =~ Resolv::IPv4::Regex)
        @config.name
      else
        @config.host.partition('.').first
      end
    end

    def execute(sentence)
      "--execute='#{sentence}'" unless sentence.nil? || sentence.empty?
    end

    def password(password)
      "-p#{password}" unless password.nil? || password.empty?
    end

    def console(sentence = nil)
      command = %W[mysql
                   -h #{@config.host}
                   -P #{@config.mysql[:port]}
                   -u #{@config.mysql[:username]}
                   #{password(@config.mysql[:password])}
                   --prompt='#{prompt}[\\d]> '
                   #{@config.mysql[:database]}
                   #{execute(sentence)}
                   2>/dev/null].join(' ')
      purge(command)
    end

    def describe(*args)
      command = %W[mysqlshow
                   -h #{@config.host}
                   -P #{@config.mysql[:port]}
                   -u #{@config.mysql[:username]}
                   #{password(@config.mysql[:password])}
                   --keys
                   #{args.join(' ')}
                   2>/dev/null].join(' ')
      purge(command)
    end
  end
end
